package com.belkast.soap;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVRecord;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;

public class userVerify
{
    public static void main (String[] args) {
        System.out.println();
        Scanner myObj = new Scanner(System.in);  // Create a Scanner object

        String varFileName;
        while (true) {
            System.out.print("Please enter the name of the CSV file to verify : ");
            varFileName = myObj.nextLine();  // Read user input
            File thisFile = new File(varFileName);
            if (thisFile.exists())
            {
                break;
            }
        }

        System.out.println();
        System.out.println("CSV input file  : " + varFileName);
        ArrayList thisCSV = readCSV(varFileName, true);
        System.out.println();

        Iterator<Map> mapper1 = thisCSV.iterator();
        int varIter = 0;
        while (mapper1.hasNext())
        {
            varIter++;
            Map thisMap = mapper1.next();
            Iterator<Map.Entry<Integer, Integer>> it = thisMap.entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry<Integer, Integer> pair = it.next();
                System.out.println("record " + varIter + " key : " + pair.getKey());
                System.out.println("record " + varIter + " val : " + pair.getValue());
            }
            System.out.println();
        }
        boolean validfile = (!thisCSV.isEmpty());
        System.out.println("CSV file records  : " + varIter);
        System.out.println("CSV file is valid : " + validfile);
        System.out.println();
    }

        public static ArrayList readCSV (String thisFile, boolean fromUser)
        {
            int readNum = 0;
            int invalidNum = 0;
            ArrayList finalArray = new ArrayList();
            File varFile = new File (thisFile);
            if (!varFile.exists()) {
                System.out.println(varFile + " does not exist. Please enter a valid filename!");
                System.exit(0);
            }

            String exceptionReason = null;
            Boolean failedOnException = false;
            Boolean parsedCorrectly = false;
            long lineNum = 0;

            while (!parsedCorrectly && !failedOnException) {
                try (final Reader in = new InputStreamReader(new FileInputStream(varFile.getPath()), "UTF-8"))
                {
                    String varHeader = new String();
                    varHeader = fileProcessor.readFirstLine(thisFile);
                    if (varHeader.length() == 0) {
                        System.out.println(thisFile + " : the CSV file appears to be missing a valid header!");
                        return finalArray;
                    }

                    CSVFormat csvFormat = CSVFormat.RFC4180.builder()
                            .setHeader(varHeader.split(","))
                            .setSkipHeaderRecord(true)
                            .setIgnoreEmptyLines(true)
                            .setIgnoreSurroundingSpaces(true)
                            .setTrim(true)
                            .build();

                    int headerLen = csvFormat.getHeader().length;
                    Iterable<CSVRecord> records = csvFormat.parse(in);

                    debugProcessor.writer(fromUser, "CSV token count : " + headerLen);
                    debugProcessor.writer(fromUser, "CSV token list  : " + varHeader);
                    debugProcessor.writer(fromUser, "");

                    for (CSVRecord record : records) {
                        readNum++;
                        lineNum = record.getParser().getCurrentLineNumber();
                        boolean isValid = record.isConsistent();

                        if (isValid)
                        {
                            finalArray.add(record.toMap());
                            debugProcessor.writer(fromUser, "## " + lineNum + " [passed]");
                        }
                        else
                        {
                            invalidNum++;
                            String thisLine = Files.readAllLines(Paths.get(thisFile)).get(Math.toIntExact(lineNum - 1));
                            debugProcessor.writer(fromUser, "!! " + lineNum + " [failed] : " + thisLine);
                            debugProcessor.writer(fromUser, "!! " + lineNum + " [failed] : " + record.toMap().toString());
                        }
                    }
                }
                catch (IOException | IllegalArgumentException e)
                {
                    exceptionReason = e.toString();
                    failedOnException = true;
                    break;
                }
                parsedCorrectly = true;
            }

                debugProcessor.writer(fromUser,"");
                debugProcessor.writer(fromUser, "CSV lines read    : " + String.valueOf(readNum));
                debugProcessor.writer(fromUser, "CSV lines passed  : " + String.valueOf(readNum - invalidNum));
                debugProcessor.writer(fromUser, "CSV lines failed  : " + invalidNum);
                if (exceptionReason != null)
                {
                    debugProcessor.writer(fromUser, "CSV failure error : " + exceptionReason);
                }

            if (invalidNum > 0)
            {
                finalArray = new ArrayList();
            }

            return finalArray;
        }
}
